package com.sun.xml.internal.messaging.saaj.soap.impl;

import org.w3c.dom.Node;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPElement;
import com.sun.xml.internal.messaging.saaj.soap.SOAPDocumentImpl;
import java.util.logging.Logger;
import javax.xml.soap.Text;

public class TextImpl extends com.sun.org.apache.xerces.internal.dom.TextImpl implements javax.xml.soap.Text, Text
{
    protected static final Logger log;
    
    public TextImpl(SOAPDocumentImpl ownerDoc, String text) {
        super(ownerDoc, text);
    }
    
    public String getValue() {
        String nodeValue = this.getNodeValue();
        return nodeValue.equals("") ? null : nodeValue;
    }
    
    public void setValue(String text) {
        this.setNodeValue(text);
    }
    
    public void setParentElement(SOAPElement parent) throws SOAPException {
        if (parent == null) {
            TextImpl.log.severe("SAAJ0126.impl.cannot.locate.ns");
            throw new SOAPException("Cannot pass NULL to setParentElement");
        }
        ((ElementImpl)parent).addNode(this);
        return;
    }
    
    public SOAPElement getParentElement() {
        return (SOAPElement)this.getParentNode();
    }
    
    public void detachNode() {
        Node parent = this.getParentNode();
        if (parent != null) {
            parent.removeChild(this);
        }
    }
    
    public void recycleNode() {
        this.detachNode();
    }
    
    public boolean isComment() {
        String txt = this.getNodeValue();
        return txt != null && txt.startsWith("<!--") && txt.endsWith("-->");
    }
    
    static {
        log = Logger.getLogger("com.sun.xml.internal.messaging.saaj.soap.impl", "com.sun.xml.internal.messaging.saaj.soap.impl.LocalStrings");
    }
}
